function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import { BizGlobalDataContext } from '@zgfe/business-lib';
import { notification } from 'antd';
import React, { useContext, useEffect, useState } from 'react';
import CategoryList from '../../components/categoryList';
import apis from '../../constants/api';
import LinkEditor from '../../components/linkEditor';
import LinkListPanel from '../../components/linkList';
import request from '../../utils/ajax';
import './index.less';
import _ from 'lodash';
import { CdpContext } from '../../context';
var CdpLinkIndex = function CdpLinkIndex() {
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    currentLink = _useState2[0],
    setCurrentLink = _useState2[1];
  var _useState3 = useState([]),
    _useState4 = _slicedToArray(_useState3, 2),
    list = _useState4[0],
    setList = _useState4[1];
  var _useState5 = useState(),
    _useState6 = _slicedToArray(_useState5, 2),
    addType = _useState6[0],
    setAddType = _useState6[1];
  var _useState7 = useState(),
    _useState8 = _slicedToArray(_useState7, 2),
    currentCategory = _useState8[0],
    setCurrentCategory = _useState8[1];
  var _useContext = useContext(CdpContext),
    categoryList = _useContext.categoryList;
  var _useContext2 = useContext(BizGlobalDataContext),
    currentApp = _useContext2.currentApp,
    route = _useContext2.route,
    currentProject = _useContext2.currentProject;
  useEffect(function () {
    queryData();
  }, []);
  useEffect(function () {
    var _route$query;
    if ((categoryList === null || categoryList === void 0 ? void 0 : categoryList.length) === 1) {
      setCurrentLink(undefined);
      setCurrentCategory(categoryList[0]);
      setAddType(categoryList[0].name);
    }
    if ((categoryList === null || categoryList === void 0 ? void 0 : categoryList.length) && (currentApp === null || currentApp === void 0 ? void 0 : currentApp.appVersion) === 2 && (route === null || route === void 0 ? void 0 : (_route$query = route.query) === null || _route$query === void 0 ? void 0 : _route$query.category)) {
      setCurrentLink({
        type: route.query.category,
        name: route.query.category
      });
      setAddType(route.query.category);
      switch (route.query.category) {
        case 'api':
          setCurrentCategory(categoryList[categoryList.length - 1]);
          break;
        case 'MySQL':
          setCurrentCategory(categoryList[0]);
          break;
      }
    }
  }, [categoryList]);
  function onEdit(data) {
    if (!(categoryList === null || categoryList === void 0 ? void 0 : categoryList.find(function (item) {
      return item.name === (/local|ftp/.test(data.type) ? 'excel' : data.type);
    }))) {
      notification.error({
        message: '当前为免费版本，不支持编辑非excel导入'
      });
      return;
    }
    setAddType(undefined);
    setCurrentLink(data);
    setCurrentCategory(categoryList === null || categoryList === void 0 ? void 0 : categoryList.find(function (item) {
      return item.name === (/local|ftp/.test(data.type) ? 'excel' : data.type);
    }));
  }
  function onAdd(category) {
    setCurrentLink(undefined);
    setCurrentCategory(category);
    setAddType(category.name);
  }
  function afterAdd(data) {
    if (currentLink) {
      // 编辑模式
      setList(function (list) {
        var res = _.cloneDeep(list);
        res.forEach(function (item, i) {
          if (item.id === data.id) {
            res[i] = data;
          }
        });
        return res;
      });
      setCurrentLink(undefined);
    } else {
      // 新增模式, 添加到列表第一个
      setList(function (list) {
        var res = _.cloneDeep(list);
        res.unshift(data);
        return res;
      });
      setAddType(undefined);
    }
  }
  function onDel(id) {
    if (currentLink && currentLink.id === id) setCurrentLink(undefined);
    setList(function (list) {
      var res = _.cloneDeep(list);
      res.forEach(function (item, i) {
        if (item.id === id) res.splice(i, 1);
      });
      return res;
    });
  }
  function queryData() {
    request(apis.queryLinkList, {
      method: 'post',
      data: {
        projectId: currentProject === null || currentProject === void 0 ? void 0 : currentProject.projectId
      }
    }).then(function (res) {
      if (!res) return;
      setList(res.data);
    }).catch(function (err) {
      console.error('加载列表数据失败', err);
      notification.error({
        message: '加载列表数据失败'
      });
    });
  }
  return /*#__PURE__*/React.createElement("div", {
    className: "cdp-link-home"
  }, list.length ? (/*#__PURE__*/React.createElement(LinkListPanel, {
    onEdit: onEdit,
    current: currentLink,
    list: list,
    onDel: onDel
  })) : null, currentLink || addType && currentCategory ? (/*#__PURE__*/React.createElement("div", {
    className: "cdp-link-to-editor"
  }, /*#__PURE__*/React.createElement(LinkEditor, {
    category: currentCategory,
    data: currentLink,
    onCancel: function onCancel() {
      setCurrentLink(undefined);
      setAddType(undefined);
    },
    onOk: afterAdd
  }))) : (/*#__PURE__*/React.createElement(CategoryList, {
    onClick: onAdd
  })));
};
export default CdpLinkIndex;